import sys
import collections 
from optparse import OptionParser, OptionGroup

#Author: Martin Kapun


#########################################################   HELP   #########################################################################
usage="python %prog --input candidates_BE.cmh --bin 100 --max-dist 10000 > candidates_BE.dist"
parser = OptionParser(usage=usage)
group=OptionGroup(parser,"""	

H E L P :
_________

Description:
This script calculates the distance between neighboring SNPs and bins (--bins) these distances until a maximum distance (--max-dist) All SNPs with neighbors beyond this threshold are stored in the largest bin
The output contains two columns with the bins and the corresponding counts
""") 
#########################################################   CODE   #########################################################################

parser.add_option("-b","--bin", dest="bin", help="binsize")
parser.add_option("-m","--max-dist", dest="max", help="maximum distance until SNPs are binned")
parser.add_option("-i","--input", dest="inp", help="input sync file")
parser.add_option_group(group)
(options, args) = parser.parse_args()



binsize=float(options.bin)
binhash=collections.defaultdict(lambda:0)
start=0
end=binsize
final=int(options.max)
## make dictionary of bins
while(end<final):
	binhash[end]
	end+=binsize
binhash[final]


disth=collections.defaultdict(lambda:[])
## fill SNP positions in dictionary
for l in open(options.inp,"r"):
	a=l.split()
	disth[a[0]].append(int(a[1]))
## fill bins 
for k,v in sorted(disth.items()):
	c=0
	for pos in sorted(v):
		if c==0:
			start=pos
			c+=1
		else:
			end=pos
			dist=end-start
			start=end
			if dist<final:
				for k in binhash.keys():
					if dist<=k and dist >=k-binsize:
						binhash[k]+=1
			else:
				binhash[final]+=1
for k,v in sorted(binhash.items()):
	print "\t".join(map(str,[k,v]))
